
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;

import static java.lang.System.out;

/**
 * Crypto 1 Week 5 Program
 * <p/>
 * Finds the Discrete logarithm of h base g modulo p: Dlog_g(h) in Zp
 * solution = 375374217830
 * elapsed time 7395 ms
 * Created by javi on 2/23/14.
 */
public class W5Program {

    BigInteger p = new BigInteger("1340780792994259709957402499820584612747936582059239337772356144372176403007354697680" +
            "1874298166903427690031858186486050853753882811946569946433649006084171");

    BigInteger g = new BigInteger("1171782988036620700951611759633536708855808499999895220559997945906392949973658374667" +
            "0572176471460312928594829675428279466566527115212748467589894601965568");

    BigInteger h = new BigInteger("3239475104050450443565264378728065788649097520952449527834792452971981976143292558073" +
            "856937958553180532878928001494706097394108577585732452307673444020333");

    public static void main(String[] args) {
        long t0 = System.currentTimeMillis();
        BigInteger solution = new W5Program().solve();
        long t1 = System.currentTimeMillis();
        out.println("solution = " + solution);
        out.println("elapsed time " + (t1 - t0));
    }


    public BigInteger solve() {
        BigInteger ginv = g.modInverse(p);
        int B = (int) Math.pow(2, 20);
        Map<BigInteger, Integer> lvals = new HashMap<BigInteger,Integer>(B);
        BigInteger left = h;
        lvals.put(left, 0);
        for (int x1 = 1; x1 <= B; x1++) {
            left = left.multiply(ginv).mod(p);
            lvals.put(left, x1);
        }
        Integer x1;
        BigInteger gB = g.modPow(BigInteger.valueOf(B), p);
        BigInteger right = BigInteger.ONE;
        for (int x0 = 1; x0 <= B; x0++) {
            right = right.multiply(gB).mod(p);
            if (null != (x1 = lvals.get(right))) {
                return BigInteger.valueOf(x0).multiply(BigInteger.valueOf(B)).add(BigInteger.valueOf(x1));
            }
        }
        return null;
    }

}
